#include "xio.h"
#include "xparameters.h"

#define apu_write_register(address, value) XIo_Out32(address, value)

void delay(unsigned int d)
{
  unsigned int j;
  
  //Simulate delay 
  for (j = 0; j < d; j++);
}

void rectangle_test()
{
  //Enable rectangle1
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 84, 0x01);

  //delay(100000);

  //Simple tone - duty 00
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 0, 0x3f);		//write to register 1
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 4, 0x00);   //write to register 2
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 8, 0x09);   //write to register 3
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 12, 0x02);  //write to register 4
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 84, 0x01);
  
  //Delay
  delay(2000000);
   
  //Simple tone - duty 01
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 0, 0x7f);		//write to register 1
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 4, 0x00);   //write to register 2
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 8, 0x09);   //write to register 3
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 12, 0x02);  //write to register 4
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 84, 0x01);
  

  //Delay
  delay(2000000);
  
  //Simple tone - duty 10
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 0, 0xbf);		//write to register 1
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 4, 0x00);   //write to register 2
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 8, 0x09);   //write to register 3
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 12, 0x02);  //write to register 4
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 84, 0x01);
  
  //Delay
  delay(2000000);
  
  //Simple tone - duty 11
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 0, 0xff);		//write to register 1
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 4, 0x00);   //write to register 2
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 8, 0x09);   //write to register 3
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 12, 0x02);  //write to register 4
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 84, 0x01);
  
  //Delay
  delay(2000000);
  
  //Envelope Decay
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 0, 0x29);		//write to register 1
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 4, 0x00);   //write to register 2
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 8, 0x09);   //write to register 3
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 12, 0xf2);  //write to register 4
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 84, 0x01);
  
  
  //Delay
  delay(4000000);
  
  //Frequency Sweep
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 0, 0x3f);		//write to register 1
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 4, 0xfc);   //write to register 2
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 8, 0x09);   //write to register 3
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 12, 0x02);  //write to register 4
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 84, 0x01);
  
  //Delay
  delay(4000000);
  
  //Silence
  apu_write_register (XPAR_APU_OPB_0_BASEADDR + 84, 0x00);

 

	
}

int main()
{
  rectangle_test();
  return 0;
}
