#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:D:\ece532\project\system\system.xmp
#################################################################

XILINX_EDK_DIR = C:/EDK

SYSTEM = system

MHSFILE = system.mhs

MSSFILE = system.mss

FPGA_ARCH = virtex2p

DEVICE = xc2vp30ff896-7

LANGUAGE = verilog

SEARCHPATHOPT =  -lp D:/ece532/lib/

SUBMODULE_OPT = 

PLATGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(SUBMODULE_OPT)

LIBGEN_OPTIONS = -mhs $(MHSFILE) -p $(DEVICE) $(SEARCHPATHOPT) \
                   $(MICROBLAZE_0_LIBG_OPT)

VPGEN_OPTIONS = -p $(DEVICE) $(SEARCHPATHOPT)

APU_MICROBENCH_OUTPUT_DIR = apu_microbench
APU_MICROBENCH_OUTPUT = $(APU_MICROBENCH_OUTPUT_DIR)/executable.elf

APU_MACROBENCH_OUTPUT_DIR = apu_macrobench
APU_MACROBENCH_OUTPUT = $(APU_MACROBENCH_OUTPUT_DIR)/executable.elf

MICROBLAZE_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/microblaze/mb_bootloop.elf
PPC405_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/ppc405/ppc_bootloop.elf
PPC440_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/ppc440/ppc440_bootloop.elf
BOOTLOOP_DIR = bootloops

MICROBLAZE_0_BOOTLOOP = $(BOOTLOOP_DIR)/microblaze_0.elf
MICROBLAZE_0_XMDSTUB = microblaze_0/code/xmdstub.elf

BRAMINIT_ELF_FILES =  $(APU_MACROBENCH_OUTPUT)  $(MICROBLAZE_0_XMDSTUB) 
BRAMINIT_ELF_FILE_ARGS =   -pe microblaze_0 $(APU_MACROBENCH_OUTPUT)  $(MICROBLAZE_0_XMDSTUB) 

ALL_USER_ELF_FILES = $(APU_MICROBENCH_OUTPUT) $(APU_MACROBENCH_OUTPUT) 

SIM_CMD = vsim

BEHAVIORAL_SIM_SCRIPT = simulation/behavioral/$(SYSTEM).do

STRUCTURAL_SIM_SCRIPT = simulation/structural/$(SYSTEM).do

TIMING_SIM_SCRIPT = simulation/timing/$(SYSTEM).do

DEFAULT_SIM_SCRIPT = $(BEHAVIORAL_SIM_SCRIPT)

MIX_LANG_SIM_OPT = -mixed yes

SIMGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(BRAMINIT_ELF_FILE_ARGS) $(MIX_LANG_SIM_OPT)  -s mti -X sim -E sim

MICROBLAZE_0_XMDSTUB = microblaze_0/code/xmdstub.elf

LIBRARIES =  \
       microblaze_0/lib/libxil.a 
VPEXEC = virtualplatform/vpexec.exe

LIBSCLEAN_TARGETS = microblaze_0_libsclean 

PROGRAMCLEAN_TARGETS = apu_microbench_programclean apu_macrobench_programclean 

CORE_STATE_DEVELOPMENT_FILES = 

WRAPPER_NGC_FILES = implementation/microblaze_0_wrapper.ngc \
implementation/mb_opb_wrapper.ngc \
implementation/debug_module_wrapper.ngc \
implementation/ilmb_wrapper.ngc \
implementation/dlmb_wrapper.ngc \
implementation/dlmb_cntlr_wrapper.ngc \
implementation/ilmb_cntlr_wrapper.ngc \
implementation/lmb_bram_wrapper.ngc \
implementation/rs232_uart_1_wrapper.ngc \
implementation/dcm_0_wrapper.ngc \
implementation/apu_opb_0_wrapper.ngc \
implementation/opb_bram_if_cntlr_0_wrapper.ngc \
implementation/bram_block_0_wrapper.ngc \
implementation/dcm_nes_cpu_wrapper.ngc

POSTSYN_NETLIST = implementation/$(SYSTEM).ngc

SYSTEM_BIT = implementation/$(SYSTEM).bit

DOWNLOAD_BIT = implementation/download.bit

SYSTEM_ACE = implementation/$(SYSTEM).ace

UCF_FILE = data/system.ucf

BMM_FILE = implementation/$(SYSTEM).bmm

BITGEN_UT_FILE = etc/bitgen.ut

XFLOW_OPT_FILE = etc/fast_runtime.opt
XFLOW_DEPENDENCY = __xps/xpsxflow.opt $(XFLOW_OPT_FILE)

XPLORER_DEPENDENCY = __xps/xplorer.opt
XPLORER_OPTIONS = -p $(DEVICE) -uc $(SYSTEM).ucf -bm $(SYSTEM).bmm -max_runs 7

FPGA_IMP_DEPENDENCY = $(BMM_FILE) $(POSTSYN_NETLIST) $(UCF_FILE) $(BITGEN_UT_FILE) $(XFLOW_DEPENDENCY)

#################################################################
# SOFTWARE APPLICATION APU_MICROBENCH
#################################################################

APU_MICROBENCH_SOURCES = code/microbench.c 

APU_MICROBENCH_HEADERS = 

APU_MICROBENCH_CC = mb-gcc
APU_MICROBENCH_CC_SIZE = mb-size
APU_MICROBENCH_CC_OPT = -O0
APU_MICROBENCH_CFLAGS = 
APU_MICROBENCH_CC_SEARCH = # -B
APU_MICROBENCH_LIBPATH = -L./microblaze_0/lib/ # -L
APU_MICROBENCH_INCLUDES = -I./microblaze_0/include/ # -I
APU_MICROBENCH_LFLAGS = # -l
APU_MICROBENCH_LINKER_SCRIPT = 
APU_MICROBENCH_LINKER_SCRIPT_FLAG = #-Wl,-T -Wl,$(APU_MICROBENCH_LINKER_SCRIPT) 
APU_MICROBENCH_CC_DEBUG_FLAG =  -g 
APU_MICROBENCH_CC_PROFILE_FLAG = # -pg
APU_MICROBENCH_CC_GLOBPTR_FLAG= # -mxl-gp-opt
APU_MICROBENCH_MODE = xmdstub
APU_MICROBENCH_LIBG_OPT = -$(APU_MICROBENCH_MODE) microblaze_0
APU_MICROBENCH_CC_SOFTMUL_FLAG= -mno-xl-soft-mul 
APU_MICROBENCH_CC_START_ADDR_FLAG=  # -Wl,-defsym -Wl,_TEXT_START_ADDR=
APU_MICROBENCH_CC_STACK_SIZE_FLAG=  # -Wl,-defsym -Wl,_STACK_SIZE=
APU_MICROBENCH_CC_HEAP_SIZE_FLAG=  # -Wl,-defsym -Wl,_HEAP_SIZE=
APU_MICROBENCH_OTHER_CC_FLAGS=  -mcpu=v5.00.c $(APU_MICROBENCH_CC_GLOBPTR_FLAG)  \
                  $(APU_MICROBENCH_CC_START_ADDR_FLAG) $(APU_MICROBENCH_CC_STACK_SIZE_FLAG) $(APU_MICROBENCH_CC_HEAP_SIZE_FLAG)  \
                  $(APU_MICROBENCH_CC_SOFTMUL_FLAG)  -mxl-pattern-compare \
                  $(APU_MICROBENCH_LINKER_SCRIPT_FLAG) $(APU_MICROBENCH_CC_DEBUG_FLAG) $(APU_MICROBENCH_CC_PROFILE_FLAG) 

#################################################################
# SOFTWARE APPLICATION APU_MACROBENCH
#################################################################

APU_MACROBENCH_SOURCES = code/macrobench.c 

APU_MACROBENCH_HEADERS = code/music.h 

APU_MACROBENCH_CC = mb-gcc
APU_MACROBENCH_CC_SIZE = mb-size
APU_MACROBENCH_CC_OPT = -O0
APU_MACROBENCH_CFLAGS = 
APU_MACROBENCH_CC_SEARCH = # -B
APU_MACROBENCH_LIBPATH = -L./microblaze_0/lib/ # -L
APU_MACROBENCH_INCLUDES = -I./microblaze_0/include/  -Icode/ # -I
APU_MACROBENCH_LFLAGS = # -l
APU_MACROBENCH_LINKER_SCRIPT = 
APU_MACROBENCH_LINKER_SCRIPT_FLAG = #-Wl,-T -Wl,$(APU_MACROBENCH_LINKER_SCRIPT) 
APU_MACROBENCH_CC_DEBUG_FLAG =  -g 
APU_MACROBENCH_CC_PROFILE_FLAG = # -pg
APU_MACROBENCH_CC_GLOBPTR_FLAG= # -mxl-gp-opt
APU_MACROBENCH_MODE = xmdstub
APU_MACROBENCH_LIBG_OPT = -$(APU_MACROBENCH_MODE) microblaze_0
APU_MACROBENCH_CC_SOFTMUL_FLAG= -mno-xl-soft-mul 
APU_MACROBENCH_CC_START_ADDR_FLAG=  # -Wl,-defsym -Wl,_TEXT_START_ADDR=
APU_MACROBENCH_CC_STACK_SIZE_FLAG=  # -Wl,-defsym -Wl,_STACK_SIZE=
APU_MACROBENCH_CC_HEAP_SIZE_FLAG=  # -Wl,-defsym -Wl,_HEAP_SIZE=
APU_MACROBENCH_OTHER_CC_FLAGS=  -mcpu=v5.00.c $(APU_MACROBENCH_CC_GLOBPTR_FLAG)  \
                  $(APU_MACROBENCH_CC_START_ADDR_FLAG) $(APU_MACROBENCH_CC_STACK_SIZE_FLAG) $(APU_MACROBENCH_CC_HEAP_SIZE_FLAG)  \
                  $(APU_MACROBENCH_CC_SOFTMUL_FLAG)  -mxl-pattern-compare \
                  $(APU_MACROBENCH_LINKER_SCRIPT_FLAG) $(APU_MACROBENCH_CC_DEBUG_FLAG) $(APU_MACROBENCH_CC_PROFILE_FLAG) 
